<template>
    <a-drawer
        :title="formData.id ? '编辑用户微信推送消息表' : '增加用户微信推送消息表'"
        :width="600"
        :visible="visible"
        :destroy-on-close="true"
        :footer-style="{ textAlign: 'right' }"
        @close="onClose"
    >
        <a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
            <a-form-item label="用户id：" name="userId">
                <a-input v-model:value="formData.userId" placeholder="请输入用户id" allow-clear />
            </a-form-item>
            <a-form-item label="公众号OpenId：" name="openId">
                <a-input v-model:value="formData.openId" placeholder="请输入公众号OpenId" allow-clear />
            </a-form-item>
            <a-form-item label="发送消息：" name="sendMsg">
                <a-input v-model:value="formData.sendMsg" placeholder="请输入发送消息" allow-clear />
            </a-form-item>
            <a-form-item label="返回消息：" name="backMsg">
                <a-input v-model:value="formData.backMsg" placeholder="请输入返回消息" allow-clear />
            </a-form-item>
        </a-form>
        <template #footer>
            <a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
            <a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
        </template>
    </a-drawer>
</template>

<script setup name="sysUserWxOpenSendLogForm">
    import { cloneDeep } from 'lodash-es'
    import { required } from '@/utils/formRules'
    import sysUserWxOpenSendLogApi from '@/api/biz/sysUserWxOpenSendLogApi'
    // 抽屉状态
    const visible = ref(false)
    const emit = defineEmits({ successful: null })
    const formRef = ref()
    // 表单数据
    const formData = ref({})
    const submitLoading = ref(false)

    // 打开抽屉
    const onOpen = (record) => {
        visible.value = true
        if (record) {
            let recordData = cloneDeep(record)
            formData.value = Object.assign({}, recordData)
        }
    }
    // 关闭抽屉
    const onClose = () => {
        formRef.value.resetFields()
        formData.value = {}
        visible.value = false
    }
    // 默认要校验的
    const formRules = {
    }
    // 验证并提交数据
    const onSubmit = () => {
        formRef.value
            .validate()
            .then(() => {
                submitLoading.value = true
                const formDataParam = cloneDeep(formData.value)
                sysUserWxOpenSendLogApi
                    .sysUserWxOpenSendLogSubmitForm(formDataParam, !formDataParam.id)
                    .then(() => {
                        onClose()
                        emit('successful')
                    })
                    .finally(() => {
                        submitLoading.value = false
                    })
            })
    }
    // 抛出函数
    defineExpose({
        onOpen
    })
</script>
